<template>
  <q-card>
    <q-img :src="urlFoto">
      <template v-slot:loading>
        <div class="text-subtitle1 text-blue">Cargando foto personal</div>
      </template>
      <template v-slot:error>
        <div class="absolute-full flex flex-center bg-negative text-white">
          Error al cargar la foto
        </div>
      </template>
    </q-img>
    <div class="absolute-bottom text-right text-white">
      <q-btn
        flat
        round
        color="white"
        size="lg"
        icon="photo_camera"
        class="q-ma-sm"
        @click="$refs.uploadFile.pickFiles()"
      />
    </div>
    <!-- @click="dialogFoto = true" -->

    <q-file
      v-show="false"
      v-model="nuevaFoto"
      ref="uploadFile"
      @update:model-value="subirFoto"
    />

    <Loading :showing="loading" />
  </q-card>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { useUserStore } from 'src/stores/user';
import { api } from 'src/boot/axios';
import Loading from 'src/components/Loading.vue';
export default defineComponent({
  name: 'IndexPage',
  components: { Loading },
  setup() {
    const loading = ref(true);
    const store = useUserStore();
    const nuevaFoto = ref();
    const urlFoto = ref('');

    onMounted(() => {
      cargarFoto();
    });

    function cargarFoto() {
      urlFoto.value =
        process.env.ENV_API_HOST +
        '/api/foto/' +
        store.details.persona.uuid +
        '?random=' +
        Math.random();

      loading.value = false;
    }

    function subirFoto() {
      loading.value = true;
      const formData = new FormData();
      formData.append('foto', nuevaFoto.value);

      api
        .post('/api/persona/datos/foto', formData, {
          headers: {
            'Content-Type': 'multipart/form-data',
          },
        })
        .finally(() => {
          cargarFoto();
        });
    }

    return {
      loading,
      subirFoto,
      nuevaFoto,
      urlFoto,
      user: store.details,
    };
  },
});
</script>
